/**
 * En klass som beskriver en bokhylla.
 */

public class Bokhylla
{
    private Hylla billy[];

    /**
     * Skapar en Bokhylla med givet antal hyllor och bredd.
     * @param n     Antalet hyllor.
     * @param bredd Bredden på hyllan.
     */
    public Bokhylla(int n, int bredd)
    {
        /**
         * Konstruktorn skapar först en array som kan innehålla n
         * referenser till objekt av typen Hylla. Därefter skapas n
         * stycken objekt av typen Hylla.
         */
        billy = new Hylla[n];

        for (int i = 0; i < n; i++)
            billy[i] = new Hylla(bredd);
    }

    /**
     * Stoppar in boken på en ledig plats i bokhyllan.
     * @param b Boken att stoppa in.
     * @return <code>true</code> om boken får plats på en hylla,
     * <code>false</code> om boken inte får plats. Notera att hyllan
     * inte måste vara full för att boken inte får plats. Det betyder
     * bara att just denna bok var för bred för att få plats på någon
     * hylla.
     */
    public boolean anbringa(Bok b)
    {
        int i = 0;
        while (i < billy.length)
        {
            if (billy[i].finnsPlats(b))
            {
                billy[i].placera(b);
                return true;
            }
            i++;
        }
        return false;
    }

    /**
     * Sorterar böckerna i hyllan. Sorteringen sker en hylla i taget,
     * inga böcker flyttas mellan hyllorna. Sorteringsordningen avgörs
     * av respektive hylla.
     */
    public void sort()
    {
        for (int i = 0; i < billy.length; i++)
            billy[i].sort();
    }

    /**
     * Skriver ut bokhyllan.
     */
    public String toString()
    {
        String result = new String("");

        for (int i = 0; i < billy.length; i++)
            result += billy[i] + "\n";

        return result;
    }
}
